﻿using LuxSciWebApiWrapper.Models;
using System;
using System.Configuration;
using System.Net.Http;
using System.Threading.Tasks;

namespace LuxSciWebApiWrapper.LuxApiHttpClient
{
    public class UserHttpClient : LuxApiHttpClient 
    {

        public UserHttpClient() : base()
        {
            requestPath= ConfigurationManager.AppSettings["UserPath"];
        }

        //Get User profile
        public async Task<LuxSciResponse> GetUserProfile(string path, string authenticationCode, string hmacSignature)
        {
            requestPath=path;
            GetHTTPClient(GetHttpClientHandler(authenticationCode, hmacSignature));
            return await GetDataAsync();

        }

        //Send mail
        public async Task<LuxSciResponse> SendMail(string path, string authenticationCode, string hmacSignature, EmailRequest emailRequest)
        {
            requestPath = path;
            GetHTTPClient(GetHttpClientHandler(authenticationCode, hmacSignature));
            return await PostAsJsonAsync(emailRequest);

        }

        //Send mail with Attachment
        public async Task<LuxSciResponse> SendMailWithAttachment(string path, string authenticationCode, string hmacSignature, HttpRequestMessage request, string boundary)
        {
            requestPath = path;
            GetHTTPClient(GetHttpClientHandler(authenticationCode, hmacSignature));
            client.Timeout = TimeSpan.FromMilliseconds(300000);
            client.DefaultRequestHeaders.TryAddWithoutValidation("Content-Type", "multipart/form-data; boundary=" + boundary);

            return await SendAsync(request);

        }

        //Get email sent report
        public async Task<LuxSciResponse> GetEmailSentReport(string path, string authenticationCode, string hmacSignature)
        {
            requestPath = path;
            GetHTTPClient(GetHttpClientHandler(authenticationCode, hmacSignature));
            return await GetDataAsync();

        }

    }
}
